%define anolis_release 1

Name:	     tcprt
Version:     1.0.0
Release:     %{anolis_release}%{?dist}
Summary:     tcprt for Alibaba Cloud
License:     Mulan PSL v2
Vendor:      Alibaba Cloud
URL:         https://gitee.com/anolis/tcprt

Source0:     %{name}-%{version}.bundle
Source1:     libbpf.submodule.bundle

BuildRequires:  clang >= 15.0.7
BuildRequires:  llvm >= 15.0.7
BuildRequires:  elfutils-devel
BuildRequires:  libyaml-devel
BuildRequires:  gcc
BuildRequires:  git

Requires:       glibc

%description
tcprt provides fine-grained tcp monitoring. Require Alibaba Cloud Linux OS (Kernel version >= 5.10-017).
Maintained by Alibaba Cloud kernel networking Team.

%prep
git clone %{SOURCE0} %{name}-%{version}
git clone %{SOURCE1} %{name}-%{version}/libbpf
cd %{name}-%{version}
git submodule update --init --recursive
pwd

%build
cd %{name}-%{version}
make

%install
mkdir -p %{buildroot}/usr/share/tcprt
mkdir -p %{buildroot}/etc/tcprt

cd %{name}-%{version}
make install prefix=%{buildroot}/usr conf_prefix=%{buildroot}/etc

install -m 755 -D -p scripts/start.sh %{buildroot}/usr/share/tcprt/start.sh
install -m 755 -D -p scripts/stop.sh %{buildroot}/usr/share/tcprt/stop.sh
install -m 644 -D -p scripts/tcprt.service %{buildroot}/etc/systemd/system/tcprt.service

install -m 755 -D -p LICENSE %{buildroot}/usr/share/tcprt/LICENSE

%post
systemctl daemon-reload


%files
/usr/bin/tcprt
/usr/bin/tcprtlog
/usr/share/tcprt/tcprt.kern.o
/usr/share/tcprt/tcprt.kern.o.opraw
/usr/share/tcprt/start.sh
/usr/share/tcprt/stop.sh
/etc/systemd/system/tcprt.service
/etc/tcprt/tcprt.yaml

/usr/share/tcprt/LICENSE

%preun
systemctl stop tcprt
systemctl disable tcprt

%postun
rm -rf /usr/share/tcprt
rm -rf /etc/tcprt

%changelog
* Tue Apr 02 2024 hanqi <lulie.ll@alibaba-inc.com> - 1.0.0-1
- Init package
